#/bin/bash

set -e

PROG=`basename $0`
DIR=`dirname $0`

. $DIR/../bin/qpalma_config.sh

export data_file=$1
export parameter_dir=$2
export result_dir=$3

# handle genome
export num_contigs=`grep CONTIGS $QPALMA_genome_dir/../genome.config| sed "s/CONTIGS//g"`
#export QPALMA_contigs=`seq 1 $num_contigs`
line_num=`cat $QPALMA_genome_dir/../genome.config | grep -n CONTIGS | sed "s/\(.*\):.*/\1/g"`

stop=$((line_num+num_contigs))
start=$((line_num+1))
QPALMA_contigs=""
for i in `seq $start $stop`;
do
    QPALMA_contigs=`sed -n ${i}p $QPALMA_genome_dir/../genome.config | sed "s/^\([A-Za-z0-9]*\).*/$QPALMA_contigs,\'\1\'/g"`
done
QPALMA_contigs=`echo "$QPALMA_contigs" | sed "s/^,//g"`
export QPALMA_contigs

export sed_QPALMA_contigs=`echo "$QPALMA_contigs"|tr "\n" "," | sed "s/,$//g"`

export QPALMA_genome_result_dir=$result_dir/genome
mkdir -p $result_dir/genome
$QPALMA_PATH/galaxy/prep_genome.sh $QPALMA_genome_dir/../genome.config $result_dir/genome

# adapt QPALMA configuration file
cat $parameter_dir/galaxy.conf | grep -v "max_intron_len" | grep -v "allowed_fragments" > $result_dir/galaxy.conf

echo "allowed_fragments = [$sed_QPALMA_contigs]" >> $result_dir/galaxy.conf
echo "max_intron_len = $QPALMA_max_intron_length" >> $result_dir/galaxy.conf

# run QPALMA alignments
$QPALMA_PATH/bin/qpalma_align $result_dir/galaxy.conf $data_file $result_dir $parameter_dir/param_final.pickle

cp $result_dir/all_predictions.blat $4
