/*

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Written (W) 2007-2009 Fabio De Bona, Andre Noll, Gunnar Raetsch
Copyright (C) 2007-2009 Max-Planck-Society

*/

#ifndef __INTERVALQUERY_H__
#define __INTERVALQUERY_H__

class IntervalQuery {

   private:
      int *pos_ptr;
      int *index_ptr;
      double *score_ptr;

      int num_scores_p;
      int num_hits_p;

   public:
      IntervalQuery() {
         pos_ptr = 0;
         index_ptr = 0;
         score_ptr = 0;
         num_scores_p  = 0;
         num_hits_p    = 0;
      }
      
      ~IntervalQuery() {

         if (pos_ptr != 0)
            delete[] pos_ptr;

         if (index_ptr != 0)
            delete[] index_ptr;

         if (score_ptr != 0)
            delete[] score_ptr;
      }
   
	  int find_interval(unsigned *pos_map, off_t num_entries, unsigned begin, unsigned end, unsigned *lindex, unsigned *rindex) ;
	  
	  int mmap_file(const char *filename, int open_mode, void **map, off_t *size) ;
	  
      void interval_query(char* basename, char** score_names, int num_scores, int* interval_matrix, int num_intervals);

      int query(char* basename, char** score_names, int num_scores, int* interval_matrix, int num_intervals);

      void getResults(int* pos, int* index, double* score);

	  int getResultSize()
		  {
			  return num_hits_p ;
		  }
};

#endif // __INTERVALQUERY_H_
