#!/usr/bin/python

def parse_options(argv):

    """Parses options from the command line """

    import sys
    from optparse import OptionParser, OptionGroup

    parser = OptionParser()
    required = OptionGroup(parser, 'REQUIRED')
    required.add_option('-a', '--alignment', dest='alignment', metavar='FILE', help='optimal alignment in bed format created with sample.py', default='-')
    required.add_option('-t', '--triggered', dest='triggered', metavar='FILE', help='reads triggered by genomeparser with option -log-triggered...', default='-')
    required.add_option('-o', '--output', dest='output', metavar='FILE', help='QPalma training file', default='-')
    parser.add_option_group(required)

    (options, args) = parser.parse_args()
    
    if len(argv) < 4:
        parser.print_help()
        sys.exit(2)

    return options

def main():
    import sys
    options = parse_options(sys.argv)

    trig_reads = dict()
    idx = 0
    for trig_read in open(options.triggered, 'r'):
        if idx % 4 == 0:
            trig_reads[trig_read.strip()[1:]] = 1


    fout = open(options.output, 'w')

    for line in open(options.alignment, 'r'):
        if trig_reads.has_key(line.strip().split('\t')[3]):
            print >> fout, line,

if __name__ == '__main__':
        main()

