#!/usr/bin/python

# written by Gunnar Raetsch

# Usage: 
# 1. Provide a valid fastq file with reads.
# 2. Number of reads to be extracted from the file.

# Output (stdout)
# median read length

def getMedian(numericValues):
    theValues = sorted(numericValues)
    if len(theValues) % 2 == 1:
        return theValues[(len(theValues)+1)/2-1]
    else:
        lower = theValues[len(theValues)/2-1]
        upper = theValues[len(theValues)/2]
        return (float(lower + upper)) / 2
	
import sys
from Bio import SeqIO
import random 

# Accept a fastq file from user
in_file = sys.argv[1]
# Number of reads to be extracted from the fastq file 
max_no = int(sys.argv[2])

# open the file 
in_handle = open(in_file, "rU")
no_reads = 0
read_lengths=[] ;
for rec in SeqIO.parse(in_handle, "fastq"):
    #print rec
    no_reads += 1
    read_lengths.append(len(rec.seq))
    if no_reads>max_no:
        break
in_handle.close()

read_lengths.sort() ;

print "%i" % getMedian(read_lengths) ;

