#!/usr/bin/env python 
# -*- coding: utf-8 -*-

import sys,pdb
import os.path

def evaluate(reads_fn,predictions_fn):
   
   all_positions = {}
   for line in open(reads_fn):
      sl = line.strip().split('\t')
      read_id = sl[3]
      pos = int(sl[1])
      if len(sl[10].split(','))==2:
          size1,size2 = sl[10].split(',')
          size1,size2 = int(size1),int(size2)

          rel_start1,rel_start2 = sl[11].split(',')
          rel_start1,rel_start2 = int(rel_start1),int(rel_start2)

          e1b = pos+rel_start1
          e1e = e1b + size1
          e2b = pos+rel_start2
          e2e = e2b + size2

          all_positions[read_id] = ([e1b,e2b],[e1e,e2e])
          #print (e1b,e1e,e2b,e2e)
          
      else:
          if len(sl[10].split(','))==1:
              size1 = sl[10].split(',')
              size1 = int(size1[0])
              
              rel_start1 = sl[11].split(',')
              rel_start1 = int(rel_start1[0])
              
              e1b = pos+rel_start1
              e1e = e1b + size1
              
              all_positions[read_id] = ([e1b,e2b])
          else:
              print "invalid number of blocks?"
              print sl
              exit -1
          
      
   correct_ctr    = 0
   incorrect_ctr  = 0
   total_ctr      = 0

   for line in open(predictions_fn):
      sl = line.strip().split('\t')
      read_id = sl[0]

      number_of_exon_starts = len(filter(lambda x: x==',',sl[13]))+1
      number_of_exon_stops = len(filter(lambda x: x==',',sl[14]))+1

      assert number_of_exon_starts == number_of_exon_stops 

      all_starts = sl[13].split(',')
      all_starts = map(lambda x: int(x),all_starts)
      all_starts_ = all_starts

      all_stops = sl[14].split(',')
      all_stops = map(lambda x: int(x)+1,all_stops)
      all_stops_ = all_stops

      gt_starts,gt_stops = all_positions[read_id]
      
      gt_starts = set(gt_starts)
      gt_stops  = set(gt_stops)

      all_starts = set(all_starts)
      all_stops = set(all_stops)

      correct_starts = len(gt_starts) - len(gt_starts.difference(all_starts))
      correct_stops = len(gt_stops) - len(gt_stops.difference(all_stops))

      #false_positive_starts = len(all_starts.difference(gt_starts))
      #false_positive_stops  = len(all_stops.difference(gt_stops))

      if correct_starts == len(gt_starts) and correct_stops == len(gt_stops):
         correct_ctr += 1
      else:
         incorrect_ctr += 1
         #pdb.set_trace()
         print "incorrect alignment of read %s" % read_id
         print "true alignment:\t\t",
         for i in range(len(all_positions[read_id][0])):
             print "[%i,%i] " % (all_positions[read_id][0][i],all_positions[read_id][1][i]),
         print "\npredicted alignment:\t",
         for i in range(len(all_starts_)):
             print "[%i,%i] " % (all_starts_[i], all_stops_[i]),
         #print all_positions[read_id]
         print ""

      total_ctr += 1
      #print 

   print '\n\nPredicted spliced alignments on a total of %d reads.' % total_ctr
   print '%d where predicted correctly' % correct_ctr
   print '%d where predicted incorrectly' % incorrect_ctr

if __name__ == '__main__':
   reads_fn = sys.argv[1]
   predictions_fn = sys.argv[2]

   assert os.path.exists(reads_fn)
   assert os.path.exists(predictions_fn)

   evaluate(reads_fn,predictions_fn)
