#ifndef __GENOME_H__
#define __GENOME_H__

extern int num_contigs ;
extern char **contig_fnames;
extern char **contig_fasta_fnames;
extern char **contig_names;
extern FILE **contig_files ;
extern char *alph ;

extern int num_est_files ;
extern char **est_fnames ;

extern int num_prot_files ;
extern char **prot_fnames ;

extern int num_cdna_files ;
extern char **cdna_fnames ;

extern char *basedir ;

extern int num_annotation_files ;
extern char **annotation_fnames ;

int init_genome(char *fname) ;
void cleanup_genome() ;
int get_contig_num(char *contig_name) ;


extern int MAX_CDNA_DELETION ;
extern int MAX_CDNA_INSERTION ;
extern int MIN_INTRON_LEN     ;
extern int MAX_INTRON_LEN     ;
extern int MAX_DOUBLE_QGAP    ;
extern int MAX_DOUBLE_TGAP    ;
extern int TERMINAL_EXON_END_TOL  ;
extern int MERGE_EST_TRANSCRIPTS ;
extern int MAX_PERFECT_EST_MATCH_LEN ;
extern int BLAT_BEST_HIT_ONLY ;
extern int MIN_SSQUALITY_SCORE ;
extern int MIN_EXONQUALITY_SCORE ;

extern double MIN_EST_COVER_FRAC  ;
extern double MIN_PROT_COVER_FRAC  ;
extern double MIN_CDNA_COVER_FRAC  ;
extern double MAX_END_MISSING     ;
extern double MAX_START_MISSING   ;
extern double MAX_END_MISSING2    ;
extern double MAX_START_MISSING2  ;
extern double BLAT_BEST_HIT_MARGIN ;


#endif
